module PnoteClient
  class ConsoleDisplay
    # implement HmlToPnoteConverter Delegate
    # implement PnoteClient Delegate

    def initialize
    end

    def paragraph_converted(count:, current:)
      print_progress(count, current, "문단 변환 중")

      # Print newline when task is done
      if count == (current + 1)
        printf("\n")
      end
    end

    def binary_converted(count:, current:)
      print_progress(count, current, "바이너리 파일 변환 중")

      # Print newline when task is done
      if count == (current + 1)
        printf("\n")
      end
    end

    private

    def print_progress(count, current, title)
      printf("\r[#{title}] #{current + 1}/#{count} [%-20s]", "=" * (percentage(count, current + 1) / 5) + ">")
    end

    def percentage(count, current)
      return ((100.0 / count) * current)
    end
  end
end
