module PnoteClient
  module Documents
    class Hml
      class Char
        # Textable Element

        def self.from_tag(char_tag)
          char = self.new

          char_tag.children.each do |child|
            if child.name == 'LINEBREAK'
              char.add_text("\n")
            elsif child.name == 'TAB'
              char.add_text("\t")
            else
              char.add_text(child.content)
            end
          end

          return char
        end

        attr_reader :text

        def initialize(text = '')
          @text = text
        end

        def add_text(text)
          @text += text
        end

        def content
          # 일반 텍스트는 변환작업을 하지 않지만
          # 닮음기호는 예외 상황으로 처리
          @text.gsub(/\xf3\xb0\x81\x80/, "$\\backsim$")
        end

        def textable?
          return true
        end
      end
    end
  end
end
