require 'hwp_script_to_latex/converter'
require 'hwp_script_to_latex/validator'

module PnoteClient
  module Documents
    class Hml
      class Equation
        # Textable Element

        def self.from_tag(eq_tag)
          script = eq_tag.xpath("SCRIPT")[0].content 
          return self.new(script)
        end

        attr_reader :script

        def initialize(script)
          @script = script
          @script_validator = HwpScriptToLatex::Validator.new
          @script_converter = ::HwpScriptToLatex::Converter.new
        end

        def content
          if @script_converter
            return @script_converter.convert(@script, math_mode: true, display_mode: true)
          else
            return @script
          end
        end

        def textable?
          return true
        end

        def validate
          return @script_validator.validate(@script)
        end
      end
    end
  end
end
