module PnoteClient
  module Documents
    class Hml
      class ParagraphReader

        def initialize(paragraphs)
          @paragraphs = paragraphs
        end

        def next_paragraph
          current_paragraph = nil
          prev_paragraph = nil
          @paragraphs.each_with_index do |paragraph, index|
            current_paragraph = paragraph
            yield(current_paragraph, prev_paragraph, is_continuous_paragraph?(current_paragraph, prev_paragraph), index) if block_given?
            prev_paragraph = paragraph
          end
        end

        private

        def is_continuous_paragraph?(paragraph1, paragraph2)
          return false if paragraph1.nil? || paragraph2.nil?
          return paragraph1.style_id == paragraph2.style_id
        end
      end
    end
  end
end
