require 'pnote_client/documents/hml/paragraph'

module PnoteClient
  module Documents
    class Hml
      class Rectangle

        def self.from_tag(rect_tag)
          rect = self.new

          pg_tags = rect_tag.xpath("DRAWINGOBJECT/DRAWTEXT/PARALIST/P")
          pg_tags.each do |pg_tag|
            rect.add_paragraph(Paragraph.from_tag(pg_tag))
          end

          return rect
        end

        attr_reader :paragraph

        def initialize
          @paragraphs = []
        end

        def add_paragraph(new_paragraph)
          @paragraphs << new_paragraph
        end

        def content
          @paragraphs.map {|pg| pg.content}.join("\n")
        end

        def textable?
          return true
        end
      end
    end
  end
end
