require 'pnote_client/documents/hml/table_cell'

module PnoteClient
  module Documents
    class Hml
      class TableRow
        def self.from_tag(row_tag)
          row = self.new

          cell_tags = row_tag.xpath("CELL")
          cell_tags.each do |cell_tag|
            row.add_cell(TableCell.from_tag(cell_tag))
          end

          return row
        end

        attr_reader :cells

        def initialize
          @cells = []
        end

        def add_cell(cell)
          @cells << cell
        end

        def content
          return @cells.map {|cell| cell.content}
        end
      end
    end
  end
end
