module PnoteClient
  module Documents
    class Pnote
      attr_reader :chapters, :images

      def initialize()
        @chapters = []
        @images = []
      end

      def add_chapter(new_chapter)
        @chapters << new_chapter
      end

      def add_image(new_image)
        @images << new_image
      end

      def exercise_count
        return @chapters.sum do |chapter|
          chapter.sub_chapters.sum do |sub_chapter|
            sub_chapter.exercises.count
          end
        end
      end

      def practice_count
        return @chapters.sum do |chapter|
          chapter.sub_chapters.sum do |sub_chapter|
            sub_chapter.practices.count
          end
        end
      end
    end
  end
end
