require 'pnote_client/utils/string_util'

module PnoteClient
  module Documents
    class Pnote
      class Problem
        include Utils::StringUtil

        attr_accessor :question, :explaination
        attr_accessor :teacher_comments, :tip

        def initialize(
          question: nil, answer: nil, explaination: nil,
          choices: nil, teacher_comments: [], tip: nil
        )

          @question, @answer, @explaination, @choices, @teacher_comments, @tip =
            question, answer, explaination, choices, teacher_comments, tip
          @choice = nil
          @answer_line = nil
        end

        def add_question_line(new_line)
          @question = add_line(@question, new_line)
        end

        def add_answer_line(new_line)
          @answer_line = add_line(@answer_line, new_line)
        end

        def add_explaination_line(new_line)
          @explaination = add_line(@explaination, new_line)
        end

        def add_choice_line(new_line)
          @choice = add_line(@choice, new_line)
        end

        def answer
          return @answer if @answer
          return @answer_line&.match(/\s*\[정답\]\s*(.*)/).to_a[1]&.strip
        end

        def choices
          return @choices if @choices
          return [] if @choice.nil?

          choice_number_pattern = /①|②|③|④|⑤/
          return @choice.split(choice_number_pattern).map {|el| el.strip }.reject {|el| el.empty? }
        end

        def add_teacher_comment(new_teacher_comment)
          @teacher_comments << new_teacher_comment
        end

        def add_tip_line(new_line)
          @tip = add_line(@tip, new_line)
        end
      end
    end
  end
end
