#
#  Author: osh
#  Created: 2019-05-27
#  Last modified: 2019-05-27


module PnoteClient
  module Validators
    class Validator
      def initialize
        @errors = []
      end

      def has_error?
        return error_count > 0
      end

      def error_count
        return @errors.length
      end

      protected

      def reset_errors
        @errors = []
      end

      def add_error(error_msg)
        @errors << error_msg
      end

      def make_error(title:, problem_number:, type:, detail: nil)
        return "[에러 메시지] #{title}\n" + 
          "[에러 위치] 문제 #{problem_number}번, 유형: (#{type})\n" +
          "[상세 내용]\n#{detail}"
      end
    end
  end
end
